#property copyright "Copyright 2012, Gnomefx.hack"
#property link      "http://www.metaquotes.net"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int  MainFilterSpeed = 8;
extern int   MainFilterSlow = 16;
extern int SmallFilterSpeed = 3;
extern int  SmallFilterSlow = 12;
extern bool FirstSignalOnly = True;
extern int          MaxBars = 900;       

double Gd_100 = 1.0;
int    Gi_108 = 0;
double Gda_112[999];
double Gda_116[999];
double buffer_UP[];
double buffer_DN[];
bool Gi_128 = FALSE;
bool Gi_132 = FALSE;
int  barnumber;
int  prevsignal;


double f0_0(int Ai_0, int Ai_4) {
   if (iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_CLOSE, Ai_4 + Ai_0 + 1) == 0.0) return (0);
   int index_8 = 0;
   for (index_8 = 0; index_8 < Ai_0; index_8++) Gda_112[Ai_0 - 1 - index_8] = MathAbs(iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_CLOSE, Ai_4 + index_8) - iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_OPEN, Ai_4 + index_8));
   double Ld_12 = 2.0 / (Ai_0 + 1);
   Gda_116[0] = Gda_112[0];
   for (index_8 = 1; index_8 < Ai_0; index_8++) Gda_116[index_8] = Gda_112[index_8] * Ld_12 + (Gda_116[index_8 - 1]) * (1 - Ld_12);
   return (Gda_116[Ai_0 - 1]);
}

double f0_1(int Ai_0, int Ai_4) {
   if (iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_CLOSE, Ai_4 + Ai_0 + 1) == 0.0) return (0);
   int index_8 = 0;
   for (index_8 = 0; index_8 < Ai_0; index_8++) Gda_112[Ai_0 - 1 - index_8] = iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_CLOSE, Ai_4 + index_8) - iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_OPEN, Ai_4 + index_8);
   double Ld_12 = 2.0 / (Ai_0 + 1);
   Gda_116[0] = Gda_112[0];
   for (index_8 = 1; index_8 < Ai_0; index_8++) Gda_116[index_8] = Gda_112[index_8] * Ld_12 + (Gda_116[index_8 - 1]) * (1 - Ld_12);
   return (Gda_116[Ai_0 - 1]);
}

int init() {
   string Lsa_0[256];
   string Ls_4 = "DeltaTrend";
   IndicatorBuffers(2);
   SetIndexBuffer(0, buffer_UP);
   SetIndexArrow(0, 233);
   SetIndexLabel(0, "Long");
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexBuffer(1, buffer_DN);
   SetIndexArrow(1, 234);
   SetIndexLabel(1, "Short");
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   IndicatorShortName(Ls_4);
   for (int index_12 = 0; index_12 < 256; index_12++) Lsa_0[index_12] = CharToStr(index_12);
   int str2int_16 = StrToInteger(Lsa_0[67] + Lsa_0[111] + Lsa_0[112] + Lsa_0[121] + Lsa_0[32] + Lsa_0[82] + Lsa_0[105] + Lsa_0[103] + Lsa_0[104] + Lsa_0[116] + Lsa_0[32] +
      Lsa_0[169] + Lsa_0[32] + Lsa_0[75] + Lsa_0[97] + Lsa_0[122] + Lsa_0[97] + Lsa_0[111] + Lsa_0[111] + Lsa_0[32] + Lsa_0[50] + Lsa_0[48] + Lsa_0[49] + Lsa_0[49] + Lsa_0[32]);
   return (0);
}

void deinit() { return; }

int start() {
   int signal;
   int Li_4;
   double Ld_8;
   double Ld_16;
   string Ls_24 = "2030.09.01";
   int str2time_32 = StrToTime(Ls_24);
   if (TimeCurrent() >= str2time_32)
   {
      Alert("Maaf Sudah Expire ! Silahkan Inbox atau hub-081381377477");
      return (0);
   }
   
   for(int Li_44 = MaxBars; Li_44>=0; Li_44--)
   {
      signal = 0;
      Li_4 = Li_44;
      if (f0_0(MainFilterSpeed, Li_4) > f0_0(MainFilterSlow, Li_4 + Gi_108))
      {
         Ld_8  = f0_1(SmallFilterSpeed, Li_4);
         Ld_16 = f0_0(SmallFilterSlow, Li_4);
              if (Ld_8 > Ld_16 * Gd_100)    signal = 1;
         else if (Ld_8 < (-Ld_16) * Gd_100) signal = -1;
      }
      if (signal == 1)
      {
         if (!FirstSignalOnly || prevsignal == -1)
            buffer_UP[Li_44] = Low[Li_44]  - iATR(NULL, 0, 10, Li_44);
             prevsignal=signal;
      }
      if (signal == -1)
      {
         if (!FirstSignalOnly || prevsignal == 1)
           buffer_DN[Li_44] = High[Li_44] + iATR(NULL, 0, 10, Li_44);
            prevsignal=signal;
      }
   }
   
   if (buffer_UP[0] != EMPTY_VALUE && buffer_UP[0] != 0.0 && Gi_128 && Bars>barnumber)
   {
      barnumber=Bars;
      Gi_128 = FALSE;
      Alert("DeltaTrend Cross Trend going Up on ", Symbol(), " ", Period());
   }
   if ((!Gi_128) && (buffer_UP[0] == EMPTY_VALUE || buffer_UP[0] == 0.0)) Gi_128 = TRUE;
   if (buffer_DN[0] != EMPTY_VALUE && buffer_DN[0] != 0.0 && Gi_132 && Bars>barnumber)
   {
      barnumber=Bars;
      Gi_132 = FALSE;
      Alert("DeltaTrend Cross Trend going Down on ", Symbol(), " ", Period());
   }
   if ((!Gi_132) && (buffer_DN[0] == EMPTY_VALUE || buffer_DN[0] == 0.0)) Gi_132 = TRUE;
   return (0);
}
